Loading...
Searching...
No Matches
CSOUND_ Struct Reference

Contains all function pointers, data, and data pointers required to run one instance of Csound. More...

`#include <csoundCore.h>`

## Data Structures

struct | sread__
struct | onefileStatics__
struct | lineventStatics__
struct | musmonStatics__
struct | libsndStatics__

## Data Fields

Attributes
MYFLT(* | GetSr )(CSOUND *)
MYFLT(* | GetKr )(CSOUND *)
uint32_t(* | GetKsmps )(CSOUND *)
uint32_t(* | GetNchnls )(CSOUND *)
| Get number of output channels.
uint32_t(* | GetNchnls_i )(CSOUND *)
| Get number of input channels.
MYFLT(* | Get0dBFS )(CSOUND *)
uint64_t(* | GetKcounter )(CSOUND *)
| Get number of control blocks elapsed.
int64_t(* | GetCurrentTimeSamples )(CSOUND *)
long(* | GetInputBufferSize )(CSOUND *)
long(* | GetOutputBufferSize )(CSOUND *)
MYFLT *(* | GetInputBuffer )(CSOUND *)
MYFLT *(* | GetOutputBuffer )(CSOUND *)
void(* | SetDebug )(CSOUND *, int d)
| Set internal debug mode.
int(* | GetDebug )(CSOUND *)
int(* | GetSizeOfMYFLT )(void)
void(* | GetOParms )(CSOUND *, OPARMS *)
const char *(* | GetEnv )(CSOUND *, const char *name)
| Get environment variable.
Message printout
CS_PRINTF2 void(* | Message )(CSOUND *, const char *fmt,...)
CS_PRINTF3 void(* | MessageS )(CSOUND *, int attr, const char *fmt,...)
void(* | MessageV )(CSOUND *, int attr, const char *format, va_list args)
int(* | GetMessageLevel )(CSOUND *)
void(* | SetMessageLevel )(CSOUND *, int messageLevel)
void(* | SetMessageCallback )(CSOUND *, void(*csoundMessageCallback)(CSOUND *, int attr, const char *format, va_list valist))
Event and MIDI functionality for opcodes
int(* | SetReleaseLength )(void *p, int n)
MYFLT(* | SetReleaseLengthSeconds )(void *p, MYFLT n)
int(* | GetMidiChannelNumber )(void *p)
MCHNBLK *(* | GetMidiChannel )(void *p)
int(* | GetMidiNoteNumber )(void *p)
int(* | GetMidiVelocity )(void *p)
int(* | GetReleaseFlag )(void *p)
double(* | GetOffTime )(void *p)
MYFLT *(* | GetPFields )(void *p)
int(* | GetInstrumentNumber )(void *p)
int(* | GetZakBounds )(CSOUND *, MYFLT **)
int(* | GetTieFlag )(CSOUND *)
int(* | GetReinitFlag )(CSOUND *)
int(* | GetStrsmax )(CSOUND *)
| Current maximum number of strings, accessible through the strset and strget opcodes.
char *(* | GetStrsets )(CSOUND *, long)
MYFLT(* | Pow2 )(CSOUND *, MYFLT a)
MYFLT(* | intpow )(MYFLT, int32)
char *(* | type2string )(int type)
Arguments to opcodes
CS_TYPE *(* | GetTypeForArg )(void *p)
int(* | GetInputArgCnt )(void *p)
char *(* | GetInputArgName )(void *p, int n)
int(* | GetOutputArgCnt )(void *p)
char *(* | GetOutputArgName )(void *p, int n)
char *(* | GetString )(CSOUND *, MYFLT)
int32(* | strarg2insno )(CSOUND *, void *p, int is_string)
char *(* | strarg2name )(CSOUND *, char *, void *, const char *, int)
Memory allocation
void(* | AuxAlloc )(CSOUND *, size_t nbytes, AUXCH *auxchp)
void *(* | Malloc )(CSOUND *, size_t nbytes)
void *(* | Calloc )(CSOUND *, size_t nbytes)
void *(* | ReAlloc )(CSOUND *, void *oldp, size_t nbytes)
char *(* | Strdup )(CSOUND *, char *)
void(* | Free )(CSOUND *, void *ptr)
Function tables
int(* | hfgens )(CSOUND *, FUNC **, const EVTBLK *, int)
int(* | FTAlloc )(CSOUND *, int tableNum, int len)
int(* | FTDelete )(CSOUND *, int tableNum)
FUNC *(* | FTFind )(CSOUND *, MYFLT *argp)
| Find tables with power of two size.
FUNC *(* | FTFindP )(CSOUND *, MYFLT *argp)
| Find any table, except deferred load tables.
FUNC *(* | FTnp2Find )(CSOUND *, MYFLT *argp)
| Find any table.
int(* | GetTable )(CSOUND *, MYFLT **tablePtr, int tableNum)
int(* | TableLength )(CSOUND *, int table)
MYFLT(* | TableGet )(CSOUND *, int table, int index)
void(* | TableSet )(CSOUND *, int table, int index, MYFLT value)
void *(* | GetNamedGens )(CSOUND *)
Global and config variable manipulation
int(* | CreateGlobalVariable )(CSOUND *, const char *name, size_t nbytes)
void *(* | QueryGlobalVariable )(CSOUND *, const char *name)
void *(* | QueryGlobalVariableNoCheck )(CSOUND *, const char *name)
int(* | DestroyGlobalVariable )(CSOUND *, const char *name)
int(* | CreateConfigurationVariable )(CSOUND *, const char *name, void *p, int type, int flags, void *min, void *max, const char *shortDesc, const char *longDesc)
int(* | SetConfigurationVariable )(CSOUND *, const char *name, void *value)
int(* | ParseConfigurationVariable )(CSOUND *, const char *name, const char *value)
csCfgVariable_t *(* | QueryConfigurationVariable )(CSOUND *, const char *name)
csCfgVariable_t **(* | ListConfigurationVariables )(CSOUND *)
int(* | DeleteConfigurationVariable )(CSOUND *, const char *name)
const char *(* | CfgErrorCodeToString )(int errcode)
FFT support
MYFLT(* | GetInverseComplexFFTScale )(CSOUND *, int FFTsize)
MYFLT(* | GetInverseRealFFTScale )(CSOUND *, int FFTsize)
void(* | ComplexFFT )(CSOUND *, MYFLT *buf, int FFTsize)
void(* | InverseComplexFFT )(CSOUND *, MYFLT *buf, int FFTsize)
void(* | RealFFT )(CSOUND *, MYFLT *buf, int FFTsize)
void(* | InverseRealFFT )(CSOUND *, MYFLT *buf, int FFTsize)
void(* | RealFFTMult )(CSOUND *, MYFLT *outbuf, MYFLT *buf1, MYFLT *buf2, int FFTsize, MYFLT scaleFac)
void(* | RealFFTnp2 )(CSOUND *, MYFLT *buf, int FFTsize)
void(* | InverseRealFFTnp2 )(CSOUND *, MYFLT *buf, int FFTsize)
PVOC-EX system
int(* | PVOC_CreateFile )(CSOUND *, const char *, uint32, uint32, uint32, uint32, int32, int, int, float, float *, uint32)
int(* | PVOC_OpenFile )(CSOUND *, const char *, void *, void *)
int(* | PVOC_CloseFile )(CSOUND *, int)
int(* | PVOC_PutFrames )(CSOUND *, int, const float *, int32)
int(* | PVOC_GetFrames )(CSOUND *, int, float *, uint32)
int(* | PVOC_FrameCount )(CSOUND *, int)
int(* | PVOC_fseek )(CSOUND *, int, int)
const char *(* | PVOC_ErrorString )(CSOUND *)
int(* | PVOCEX_LoadFile )(CSOUND *, const char *, PVOCEX_MEMFILE *)
Error messages
CS_NORETURN CS_PRINTF2 void(* | Die )(CSOUND *, const char *msg,...)
CS_PRINTF2 int(* | InitError )(CSOUND *, const char *msg,...)
CS_PRINTF3 int(* | PerfError )(CSOUND *, OPDS *h, const char *msg,...)
CS_PRINTF2 void(* | Warning )(CSOUND *, const char *msg,...)
CS_PRINTF2 void(* | DebugMsg )(CSOUND *, const char *msg,...)
CS_NORETURN void(* | LongJmp )(CSOUND *, int)
CS_PRINTF2 void(* | ErrorMsg )(CSOUND *, const char *fmt,...)
void(* | ErrMsgV )(CSOUND *, const char *hdr, const char *fmt, va_list)
Random numbers
uint32_t(* | GetRandomSeedFromTime )(void)
void(* | SeedRandMT )(CsoundRandMTState *p, const uint32_t *initKey, uint32_t keyLength)
uint32_t(* | RandMT )(CsoundRandMTState *p)
int(* | Rand31 )(int *seedVal)
int(* | GetRandSeed )(CSOUND *, int which)
Threads and locks
void *(* | CreateThread )(uintptr_t(*threadRoutine)(void *), void *userdata)
uintptr_t(* | JoinThread )(void *thread)
void *(* | CreateThreadLock )(void)
void(* | DestroyThreadLock )(void *lock)
int(* | WaitThreadLock )(void *lock, size_t milliseconds)
void(* | NotifyThreadLock )(void *lock)
void(* | WaitThreadLockNoTimeout )(void *lock)
void *(* | Create_Mutex )(int isRecursive)
int(* | LockMutexNoWait )(void *mutex_)
void(* | LockMutex )(void *mutex_)
void(* | UnlockMutex )(void *mutex_)
void(* | DestroyMutex )(void *mutex_)
void *(* | CreateBarrier )(unsigned int max)
int(* | DestroyBarrier )(void *)
int(* | WaitBarrier )(void *)
void *(* | GetCurrentThreadID )(void)
void(* | Sleep )(size_t milliseconds)
void(* | InitTimerStruct )(RTCLOCK *)
double(* | GetRealTime )(RTCLOCK *)
double(* | GetCPUTime )(RTCLOCK *)
Circular lock-free buffer
void *(* | CreateCircularBuffer )(CSOUND *, int, int)
int(* | ReadCircularBuffer )(CSOUND *, void *, void *, int)
int(* | WriteCircularBuffer )(CSOUND *, void *, const void *, int)
void(* | FlushCircularBuffer )(CSOUND *, void *)
void(* | DestroyCircularBuffer )(CSOUND *, void *)
File access
char *(* | FindInputFile )(CSOUND *, const char *filename, const char *envList)
char *(* | FindOutputFile )(CSOUND *, const char *filename, const char *envList)
void *(* | SAsndgetset )(CSOUND *, char *, void *, MYFLT *, MYFLT *, MYFLT *, int)
void *(* | sndgetset )(CSOUND *, void *)
int(* | getsndin )(CSOUND *, void *, MYFLT *, int, void *)
void(* | rewriteheader )(void *ofd)
SNDMEMFILE *(* | LoadSoundFile )(CSOUND *, const char *, void *)
void(* | FDRecord )(CSOUND *, FDCH *fdchp)
void(* | FDClose )(CSOUND *, FDCH *fdchp)
void *(* | CreateFileHandle )(CSOUND *, void *, int, const char *)
char *(* | GetFileName )(void *)
int(* | FileClose )(CSOUND *, void *)
void *(* | FileOpen2 )(CSOUND *, void *, int, const char *, void *, const char *, int, int)
int(* | type2csfiletype )(int type, int encoding)
void(* | NotifyFileOpened )(CSOUND *, const char *, int, int, int)
int(* | sftype2csfiletype )(int type)
MEMFIL *(* | ldmemfile2withCB )(CSOUND *, const char *, int, int(*callback)(CSOUND *, MEMFIL *))
void *(* | FileOpenAsync )(CSOUND *, void *, int, const char *, void *, const char *, int, int, int)
unsigned int(* | ReadAsync )(CSOUND *, void *, MYFLT *, int)
unsigned int(* | WriteAsync )(CSOUND *, void *, MYFLT *, int)
int(* | FSeekAsync )(CSOUND *, void *, int, int)
char *(* | getstrformat )(int format)
int(* | sfsampsize )(int format)
RT audio IO and callbacks
void(* | SetPlayopenCallback )(CSOUND *, int(*playopen__)(CSOUND *, const csRtAudioParams *parm))
void(* | SetRtplayCallback )(CSOUND *, void(*rtplay__)(CSOUND *, const MYFLT *outBuf, int nbytes))
void(* | SetRecopenCallback )(CSOUND *, int(*recopen__)(CSOUND *, const csRtAudioParams *parm))
void(* | SetRtrecordCallback )(CSOUND *, int(*rtrecord__)(CSOUND *, MYFLT *inBuf, int nbytes))
void(* | SetRtcloseCallback )(CSOUND *, void(*rtclose__)(CSOUND *))
void(* | SetAudioDeviceListCallback )(CSOUND *csound, int(*audiodevlist__)(CSOUND *, CS_AUDIODEVICE *list, int isOutput))
void **(* | GetRtRecordUserData )(CSOUND *)
void **(* | GetRtPlayUserData )(CSOUND *)
int(* | GetDitherMode )(CSOUND *)
RT MIDI and callbacks
void(* | SetExternalMidiInOpenCallback )(CSOUND *, int(*func)(CSOUND *, void **, const char *))
void(* | SetExternalMidiReadCallback )(CSOUND *, int(*func)(CSOUND *, void *, unsigned char *, int))
void(* | SetExternalMidiInCloseCallback )(CSOUND *, int(*func)(CSOUND *, void *))
void(* | SetExternalMidiOutOpenCallback )(CSOUND *, int(*func)(CSOUND *, void **, const char *))
void(* | SetExternalMidiWriteCallback )(CSOUND *, int(*func)(CSOUND *, void *, const unsigned char *, int))
void(* | SetExternalMidiOutCloseCallback )(CSOUND *, int(*func)(CSOUND *, void *))
void(* | SetExternalMidiErrorStringCallback )(CSOUND *, const char *(*func)(int))
void(* | SetMIDIDeviceListCallback )(CSOUND *csound, int(*audiodevlist__)(CSOUND *, CS_MIDIDEVICE *list, int isOutput))
void(* | module_list_add )(CSOUND *, char *, char *)
Displays & graphs
void(* | dispset )(CSOUND *, WINDAT *, MYFLT *, int32, char *, int, char *)
void(* | display )(CSOUND *, WINDAT *)
int(* | dispexit )(CSOUND *)
void(* | dispinit )(CSOUND *)
int(* | SetIsGraphable )(CSOUND *, int isGraphable)
void(* | SetMakeGraphCallback )(CSOUND *, void(*makeGraphCallback)(CSOUND *, WINDAT *p, const char *name))
void(* | SetDrawGraphCallback )(CSOUND *, void(*drawGraphCallback)(CSOUND *, WINDAT *p))
void(* | SetKillGraphCallback )(CSOUND *, void(*killGraphCallback)(CSOUND *, WINDAT *p))
void(* | SetExitGraphCallback )(CSOUND *, int(*exitGraphCallback)(CSOUND *))
Generic callbacks
void(* | SetYieldCallback )(CSOUND *, int(*yieldCallback)(CSOUND *))
int(* | Set_KeyCallback )(CSOUND *, int(*func)(void *, void *, unsigned int), void *userData, unsigned int typeMask)
void(* | Remove_KeyCallback )(CSOUND *, int(*func)(void *, void *, unsigned int))
int(* | RegisterSenseEventCallback )(CSOUND *, void(*func)(CSOUND *, void *), void *userData)
int(* | RegisterDeinitCallback )(CSOUND *, void *p, int(*func)(CSOUND *, void *))
int(* | RegisterResetCallback )(CSOUND *, void *userData, int(*func)(CSOUND *, void *))
void(* | SetInternalYieldCallback )(CSOUND *, int(*yieldCallback)(CSOUND *))
Opcodes and instruments
int(* | AppendOpcode )(CSOUND *, const char *opname, int dsblksiz, int flags, int thread, const char *outypes, const char *intypes, int(*iopadr)(CSOUND *, void *), int(*kopadr)(CSOUND *, void *), int(*aopadr)(CSOUND *, void *))
int(* | AppendOpcodes )(CSOUND *, const OENTRY *opcodeList, int n)
char *(* | GetOpcodeName )(void *p)
INSTRTXT **(* | GetInstrumentList )(CSOUND *)
Events and performance
int(* | CheckEvents )(CSOUND *)
int(* | insert_score_event )(CSOUND *, EVTBLK *, double)
int(* | insert_score_event_at_sample )(CSOUND *, EVTBLK *, int64_t)
int(* | PerformKsmps )(CSOUND *)
Utilities
int(* | AddUtility )(CSOUND *, const char *name, int(*UtilFunc)(CSOUND *, int, char **))
int(* | RunUtility )(CSOUND *, const char *name, int argc, char **argv)
char **(* | ListUtilities )(CSOUND *)
int(* | SetUtilityDescription )(CSOUND *, const char *utilName, const char *utilDesc)
const char *(* | GetUtilityDescription )(CSOUND *, const char *utilName)
void(* | SetUtilSr )(CSOUND *, MYFLT)
void(* | SetUtilNchnls )(CSOUND *, int)
Miscellaneous
long(* | RunCommand )(const char *const *argv, int noWait)
int(* | OpenLibrary )(void **library, const char *libraryPath)
int(* | CloseLibrary )(void *library)
void *(* | GetLibrarySymbol )(void *library, const char *procedureName)
char *(* | LocalizeString )(const char *) __attribute__((format_arg(1)))
char *(* | strtok_r )(char *, char *, char **)
double(* | strtod )(char *, char **)
int(* | sprintf )(char *str, const char *format,...)
int(* | sscanf )(char *str, const char *format,...)
MYFLT(* | system_sr )(CSOUND *, MYFLT)
Score Event s
MYFLT(* | GetScoreOffsetSeconds )(CSOUND *)
void(* | SetScoreOffsetSeconds )(CSOUND *, MYFLT offset)
void(* | RewindScore )(CSOUND *)
void(* | InputMessage )(CSOUND *, const char *message__)
int(* | ISSTRCOD )(MYFLT)
void *(* | RealFFT2Setup )(CSOUND *csound, int FFTsize, int d)
void(* | RealFFT2 )(CSOUND *csound, void *p, MYFLT *sig)
int(* | ftError )(const FGDATA *, const char *,...)
MYFLT(* | GetA4 )(CSOUND *csound)
int(* | AuxAllocAsync )(CSOUND *, size_t, AUXCH *, AUXASYNC *, aux_cb, void *)
void *(* | GetHostData )(CSOUND *)
char *(* | strNcpy )(char *dst, const char *src, size_t siz)
int(* | GetZaBounds )(CSOUND *, MYFLT **)
OENTRY *(* | find_opcode_new )(CSOUND *, char *, char *, char *)
OENTRY *(* | find_opcode_exact )(CSOUND *, char *, char *, char *)
int(* | GetChannelPtr )(CSOUND *, MYFLT **, const char *, int)
int(* | ListChannels )(CSOUND *, controlChannelInfo_t **)
int(* | GetErrorCnt )(CSOUND *)
FUNC *(* | FTnp2Finde )(CSOUND *, MYFLT *)
INSTRTXT *(* | GetInstrument )(CSOUND *, int, const char *)
MYFLT *(* | AutoCorrelation )(CSOUND *, MYFLT *, MYFLT *, int, MYFLT *, int)
void *(* | LPsetup )(CSOUND *csound, int N, int M)
void(* | LPfree )(CSOUND *csound, void *)
MYFLT *(* | LPred )(CSOUND *, void *, MYFLT *)
MYFLT *(* | LPCeps )(CSOUND *, MYFLT *, MYFLT *, int, int)
MYFLT *(* | CepsLP )(CSOUND *, MYFLT *, MYFLT *, int, int)
MYFLT(* | LPrms )(CSOUND *, void *)
void *(* | CreateThread2 )(uintptr_t(*threadRoutine)(void *), unsigned int, void *userdata)
Placeholders
To allow the API to grow while maintining backward binary compatibility.
SUBR | dummyfn_2 [22]
Private Data

Private Data in the CSOUND struct to be used internally by the Csound library and should be hidden from plugins.

If a new variable member is needed by the library, add it below, as a private data member. If access is required solely by plugins (and not internally by the library), use the CreateGlobalVariable() etc. interface, instead of adding to CSOUND.

If you find that a plugin needs to access existing private data, first check above for an existing interface; if none is available, add one. Please avoid giving full access, or allowing plugins to change the values of private members, by using one of the two methods below:

1) To get the data member value:

returnType (*GetVar)(CSOUND *)
CSOUND
struct CSOUND_ CSOUND
Definition csound.h:475

2) in case of pointers, data should be copied out to a supplied memory slot, rather than the pointer being obtained:

void (*GetData)(CSOUND *, dataType *)
dataType var;
csound->GetData(csound, &var);

SUBR | first_callback_
channelCallback_t | InputChannelCallback_
channelCallback_t | OutputChannelCallback_
void(* | csoundMessageCallback_ )(CSOUND *, int attr, const char *format, va_list args)
int(* | csoundConfigureCallback_ )(CSOUND *)
void(* | csoundMakeGraphCallback_ )(CSOUND *, WINDAT *windat, const char *name)
void(* | csoundDrawGraphCallback_ )(CSOUND *, WINDAT *windat)
void(* | csoundKillGraphCallback_ )(CSOUND *, WINDAT *windat)
int(* | csoundExitGraphCallback_ )(CSOUND *)
int(* | csoundYieldCallback_ )(CSOUND *)
void(* | cscoreCallback_ )(CSOUND *)
void(* | FileOpenCallback_ )(CSOUND *, const char *, int, int, int)
SUBR | last_callback_
int(* | playopen_callback )(CSOUND *, const csRtAudioParams *parm)
void(* | rtplay_callback )(CSOUND *, const MYFLT *outBuf, int nbytes)
int(* | recopen_callback )(CSOUND *, const csRtAudioParams *parm)
int(* | rtrecord_callback )(CSOUND *, MYFLT *inBuf, int nbytes)
void(* | rtclose_callback )(CSOUND *)
int(* | audio_dev_list_callback )(CSOUND *, CS_AUDIODEVICE *, int)
int(* | midi_dev_list_callback )(CSOUND *, CS_MIDIDEVICE *, int)
int(* | doCsoundCallback )(CSOUND *, void *, unsigned int)
int(* | csoundInternalYieldCallback_ )(CSOUND *)
void(* | spinrecv )(CSOUND *)
void(* | spoutran )(CSOUND *)
int(* | audrecv )(CSOUND *, MYFLT *, int)
void(* | audtran )(CSOUND *, const MYFLT *, int)
void * | hostdata
char * | orchname
char * | scorename
CORFIL * | orchstr
CORFIL * | scorestr
OPDS * | ids
ENGINE_STATE | engineState
INSTRTXT * | instr0
INSTRTXT ** | dead_instr_pool
int | dead_instr_no
TYPE_POOL * | typePool
unsigned int | ksmps
uint32_t | nchnls
int | inchnls
int | spoutactive
uint64_t | kcounter
uint64_t | global_kcounter
MYFLT | esr
MYFLT | ekr
int64_t | icurTime
| current time in seconds, inc.
double | curTime_inc
double | timeOffs
| start time of current section
double | beatOffs
double | curBeat
| current time in beats, inc per kprd
double | curBeat_inc
int64_t | ibeatTime
| beat time = 60 / tempo
EVTBLK * | currevent
INSDS * | curip
MYFLT | cpu_power_busy
char * | xfilename
int | peakchunks
int | keep_tmp
CS_HASH_TABLE * | opcodes
int32 | nrecs
FILE * | Linepipe
int | Linefd
void * | csoundCallbacks_
FILE * | scfp
CORFIL * | scstr
FILE * | oscfp
MYFLT | maxamp [MAXCHNLS]
MYFLT | smaxamp [MAXCHNLS]
MYFLT | omaxamp [MAXCHNLS]
uint32 | maxpos [MAXCHNLS]
uint32 | smaxpos [MAXCHNLS]
uint32 | omaxpos [MAXCHNLS]
FILE * | scorein
FILE * | scoreout
int * | argoffspace
INSDS * | frstoff
void * | stdOp_Env
| reserved for std opcode library
int | holdrand
int | randSeed1
int | randSeed2
CsoundRandMTState * | csRandState
RTCLOCK * | csRtClock
int | strsmax
char ** | strsets
MYFLT * | spin
MYFLT * | spout
MYFLT * | spraw
int | nspin
int | nspout
MYFLT * | auxspin
OPARMS * | oparms
MCHNBLK * | m_chnbp [MIDIMAXPORTS *16]
| reserve space for up to MIDIMAXPORTS MIDI devices
int | dither_output
MYFLT | onedsr
MYFLT | sicvt
MYFLT | tpidsr
MYFLT | pidsr
MYFLT | mpidsr
MYFLT | mtpdsr
MYFLT | onedksmps
MYFLT | onedkr
MYFLT | kicvt
int | reinitflag
int | tieflag
MYFLT | e0dbfs
MYFLT | dbfs_to_float
double | A4
void * | rtRecord_userdata
void * | rtPlay_userdata
jmp_buf | exitjmp
SRTBLK * | frstbp
int | sectcnt
int | inerrcnt
int | synterrcnt
int | perferrcnt
INSDS | actanchor
int32 | rngcnt [MAXCHNLS]
int16 | rngflg
int16 | multichan
void * | evtFuncChain
EVTNODE * | OrcTrigEvts
EVTNODE * | freeEvtNodes
int | csoundIsScorePending_
int64_t | advanceCnt
int | initonly
int | evt_poll_cnt
int | evt_poll_maxcnt
int | Mforcdecs
int | Mxtroffs
int | MTrkend
OPCODINFO * | opcodeInfo
FUNC ** | flist
int | maxfnum
GEN * | gensub
int | genmax
CS_HASH_TABLE * | namedGlobals
CS_HASH_TABLE * | cfgVariableDB
double | prvbt
double | curbt
double | nxtbt
double | curp2
double | nxtim
int64_t | cyclesRemaining
EVTBLK | evt
void * | memalloc_db
MGLOBAL * | midiGlobals
CS_HASH_TABLE * | envVarDB
MEMFIL * | memfiles
PVOCEX_MEMFILE * | pvx_memfiles
int | FFT_max_size
void * | FFT_table_1
void * | FFT_table_2
void * | tseg
void * | tpsave
MACRO * | orc_macros
MYFLT * | gbloffbas
void * | file_io_thread
int | file_io_start
void * | file_io_threadlock
int | realtime_audio_flag
void * | event_insert_thread
int | event_insert_loop
void * | init_pass_threadlock
void * | API_lock
spin_lock_t | spoutlock
spin_lock_t | spinlock
spin_lock_t | memlock
spin_lock_t | spinlock1
char * | delayederrormessages
void * | printerrormessagesflag
struct CSOUND_::sread__ | sread
struct CSOUND_::onefileStatics__ | onefileStatics
struct CSOUND_::lineventStatics__ | lineventStatics
struct CSOUND_::musmonStatics__ | musmonStatics
struct CSOUND_::libsndStatics__ | libsndStatics
int | warped
int | sstrlen
char * | sstrbuf
int | enableMsgAttr
int | sampsNeeded
MYFLT | csoundScoreOffsetSeconds_
int | inChar_
int | isGraphable_
int | delayr_stack_depth
void * | first_delayr
void * | last_delayr
int32 | revlpsiz [6]
int32 | revlpsum
double | rndfrac
MYFLT * | logbase2
NAMES * | omacros
NAMES * | smacros
void * | namedgen
void * | open_files
void * | searchPathCache
CS_HASH_TABLE * | sndmemfiles
void * | reset_list
void * | pvFileTable
int | pvNumFiles
int | pvErrorCode
int | enableHostImplementedAudioIO
int | enableHostImplementedMIDIIO
int | hostRequestedBufferSize
char | engineStatus
char | stdin_assign_flg
char | stdout_assign_flg
char | orcname_mode
int | use_only_orchfile
void * | csmodule_db
char * | dl_opcodes_oplibs
char * | SF_csd_licence
char * | SF_id_title
char * | SF_id_copyright
int | SF_id_scopyright
char * | SF_id_software
char * | SF_id_artist
char * | SF_id_comment
char * | SF_id_date
void * | utility_db
int16 * | isintab
void * | lprdaddr
int | currentLPCSlot
int | max_lpc_slot
CS_HASH_TABLE * | chn_db
int | opcodedirWasOK
int | disable_csd_options
CsoundRandMTState | randState_
int | performState
int | ugens4_rand_16
int | ugens4_rand_15
void * | schedule_kicked
MYFLT * | disprep_fftcoefs
void * | winEPS_globals
OPARMS | oparms_
REMOT_BUF | SVrecvbuf
void * | remoteGlobals
int | nchanif
int | nchanof
char * | chanif
char * | chanof
int | multiThreadedComplete
THREADINFO * | multiThreadedThreadInfo
struct dag_t * | multiThreadedDag
void * | barrier1
void * | barrier2
void * | pointer1
void * | pointer2
int | int1
struct instr_semantics_t * | instCurr
struct instr_semantics_t * | instRoot
int | inInstr
int | dag_changed
int | dag_num_active
INSDS ** | dag_task_map
volatile stateWithPadding * | dag_task_status
watchList *volatile * | dag_task_watch
watchList * | dag_wlmm
char ** | dag_task_dep
int | dag_task_max_size
uint32_t | tempStatus
int | orcLineOffset
int | scoLineOffset
char * | csdname
int | parserUdoflag
int | parserNamedInstrFlag
int | tran_nchnlsi
int | scnt
int | strsiz
FUNC * | sinetable
int | sinelength
MYFLT * | UNUSEDP
MYFLT * | cpsocfrc
CORFIL * | expanded_orc
CORFIL * | expanded_sco
char * | filedir [256]
void * | message_buffer
int | jumpset
int | info_message_request
int | modules_loaded
MYFLT | _system_sr
void * | csdebug_data
int(* | kperf )(CSOUND *)
int | score_parser
CS_HASH_TABLE * | symbtab
int | print_version
int | inZero
struct _message_queue ** | msg_queue
volatile long | msg_queue_wget
volatile long | msg_queue_wput
volatile long | msg_queue_rstart
volatile long | msg_queue_items
int | aftouch
void * | directory
ALLOC_DATA * | alloc_queue
volatile unsigned long | alloc_queue_items
unsigned long | alloc_queue_wp
spin_lock_t | alloc_spinlock
EVTBLK * | init_event
void(* | csoundMessageStringCallback )(CSOUND *csound, int attr, const char *str)
char * | message_string
volatile unsigned long | message_string_queue_items
unsigned long | message_string_queue_wp
message_string_queue_t * | message_string_queue
int | io_initialised
char * | op
int | mode
char * | opcodedir
char * | score_srt
int | mp3_mode

## Detailed Description

Contains all function pointers, data, and data pointers required to run one instance of Csound.

PUBLIC functions in CSOUND_ These are used by plugins to access the Csound library functionality without the requirement of compile-time linkage to the csound library New functions only need to be added here if they are required by plugins.

## Field Documentation

## _system_sr

MYFLT CSOUND_::_system_sr

## A4

double CSOUND_::A4

## actanchor

INSDS CSOUND_::actanchor

## AddUtility

int(* CSOUND_::AddUtility) (CSOUND *, const char *name, int(*UtilFunc)(CSOUND *, int, char **))

## advanceCnt

int64_t CSOUND_::advanceCnt

## aftouch

int CSOUND_::aftouch

## alloc_queue

ALLOC_DATA* CSOUND_::alloc_queue

## alloc_queue_items

volatile unsigned long CSOUND_::alloc_queue_items

## alloc_queue_wp

unsigned long CSOUND_::alloc_queue_wp

## alloc_spinlock

spin_lock_t CSOUND_::alloc_spinlock

## API_lock

void* CSOUND_::API_lock

## AppendOpcode

int(* CSOUND_::AppendOpcode) (CSOUND *, const char *opname, int dsblksiz, int flags, int thread, const char *outypes, const char *intypes, int(*iopadr)(CSOUND *, void *), int(*kopadr)(CSOUND *, void *), int(*aopadr)(CSOUND *, void *))

## AppendOpcodes

int(* CSOUND_::AppendOpcodes) (CSOUND *, const OENTRY *opcodeList, int n)

## argoffspace

int* CSOUND_::argoffspace

## audio_dev_list_callback

int(* CSOUND_::audio_dev_list_callback) (CSOUND *, CS_AUDIODEVICE *, int)

## audrecv

int(* CSOUND_::audrecv) (CSOUND *, MYFLT *, int)

## audtran

void(* CSOUND_::audtran) (CSOUND *, const MYFLT *, int)

## AutoCorrelation

MYFLT *(* CSOUND_::AutoCorrelation) (CSOUND *, MYFLT *, MYFLT *, int, MYFLT *, int)

## AuxAlloc

void(* CSOUND_::AuxAlloc) (CSOUND *, size_t nbytes, AUXCH *auxchp)

## AuxAllocAsync

int(* CSOUND_::AuxAllocAsync) (CSOUND *, size_t, AUXCH *, AUXASYNC *, aux_cb, void *)

## auxspin

MYFLT* CSOUND_::auxspin

## barrier1

void* CSOUND_::barrier1

## barrier2

void* CSOUND_::barrier2

## beatOffs

double CSOUND_::beatOffs

## Calloc

void *(* CSOUND_::Calloc) (CSOUND *, size_t nbytes)

## CepsLP

MYFLT *(* CSOUND_::CepsLP) (CSOUND *, MYFLT *, MYFLT *, int, int)

## CfgErrorCodeToString

const char *(* CSOUND_::CfgErrorCodeToString) (int errcode)

## cfgVariableDB

CS_HASH_TABLE* CSOUND_::cfgVariableDB

## chanif

char* CSOUND_::chanif

## chanof

char * CSOUND_::chanof

## CheckEvents

int(* CSOUND_::CheckEvents) (CSOUND *)

## chn_db

CS_HASH_TABLE* CSOUND_::chn_db

## CloseLibrary

int(* CSOUND_::CloseLibrary) (void *library)

## ComplexFFT

void(* CSOUND_::ComplexFFT) (CSOUND *, MYFLT *buf, int FFTsize)

## cpsocfrc

MYFLT* CSOUND_::cpsocfrc

## cpu_power_busy

MYFLT CSOUND_::cpu_power_busy

## Create_Mutex

void *(* CSOUND_::Create_Mutex) (int isRecursive)

## CreateBarrier

void *(* CSOUND_::CreateBarrier) (unsigned int max)

## CreateCircularBuffer

void *(* CSOUND_::CreateCircularBuffer) (CSOUND *, int, int)

## CreateConfigurationVariable

int(* CSOUND_::CreateConfigurationVariable) (CSOUND *, const char *name, void *p, int type, int flags, void *min, void *max, const char *shortDesc, const char *longDesc)

## CreateFileHandle

void *(* CSOUND_::CreateFileHandle) (CSOUND *, void *, int, const char *)

## CreateGlobalVariable

int(* CSOUND_::CreateGlobalVariable) (CSOUND *, const char *name, size_t nbytes)

## CreateThread

void *(* CSOUND_::CreateThread) (uintptr_t(*threadRoutine)(void *), void *userdata)

## CreateThread2

void *(* CSOUND_::CreateThread2) (uintptr_t(*threadRoutine)(void *), unsigned int, void *userdata)

## CreateThreadLock

void *(* CSOUND_::CreateThreadLock) (void)

## cscoreCallback_

void(* CSOUND_::cscoreCallback_) (CSOUND *)

## csdebug_data

void* CSOUND_::csdebug_data

## csdname

char* CSOUND_::csdname

## csmodule_db

void* CSOUND_::csmodule_db

## csoundCallbacks_

void* CSOUND_::csoundCallbacks_

## csoundConfigureCallback_

int(* CSOUND_::csoundConfigureCallback_) (CSOUND *)

## csoundDrawGraphCallback_

void(* CSOUND_::csoundDrawGraphCallback_) (CSOUND *, WINDAT *windat)

## csoundExitGraphCallback_

int(* CSOUND_::csoundExitGraphCallback_) (CSOUND *)

## csoundInternalYieldCallback_

int(* CSOUND_::csoundInternalYieldCallback_) (CSOUND *)

## csoundIsScorePending_

int CSOUND_::csoundIsScorePending_

## csoundKillGraphCallback_

void(* CSOUND_::csoundKillGraphCallback_) (CSOUND *, WINDAT *windat)

## csoundMakeGraphCallback_

void(* CSOUND_::csoundMakeGraphCallback_) (CSOUND *, WINDAT *windat, const char *name)

## csoundMessageCallback_

void(* CSOUND_::csoundMessageCallback_) (CSOUND *, int attr, const char *format, va_list args)

## csoundMessageStringCallback

void(* CSOUND_::csoundMessageStringCallback) (CSOUND *csound, int attr, const char *str)

## csoundScoreOffsetSeconds_

MYFLT CSOUND_::csoundScoreOffsetSeconds_

## csoundYieldCallback_

int(* CSOUND_::csoundYieldCallback_) (CSOUND *)

## csRandState

CsoundRandMTState* CSOUND_::csRandState

## csRtClock

RTCLOCK* CSOUND_::csRtClock

## curBeat

double CSOUND_::curBeat

current time in beats, inc per kprd

## curBeat_inc

double CSOUND_::curBeat_inc

## curbt

double CSOUND_::curbt

## curip

INSDS* CSOUND_::curip

## curp2

double CSOUND_::curp2

## currentLPCSlot

int CSOUND_::currentLPCSlot

## currevent

EVTBLK* CSOUND_::currevent

## curTime_inc

double CSOUND_::curTime_inc

## cyclesRemaining

int64_t CSOUND_::cyclesRemaining

## dag_changed

int CSOUND_::dag_changed

## dag_num_active

int CSOUND_::dag_num_active

## dag_task_dep

char** CSOUND_::dag_task_dep

## dag_task_map

INSDS** CSOUND_::dag_task_map

## dag_task_max_size

int CSOUND_::dag_task_max_size

## dag_task_status

volatile stateWithPadding* CSOUND_::dag_task_status

## dag_task_watch

watchList* volatile* CSOUND_::dag_task_watch

## dag_wlmm

watchList* CSOUND_::dag_wlmm

## dbfs_to_float

MYFLT CSOUND_::dbfs_to_float

## dead_instr_no

int CSOUND_::dead_instr_no

## dead_instr_pool

INSTRTXT** CSOUND_::dead_instr_pool

## DebugMsg

CS_PRINTF2 void(* CSOUND_::DebugMsg) (CSOUND *, const char *msg,...)

## delayederrormessages

char* CSOUND_::delayederrormessages

## delayr_stack_depth

int CSOUND_::delayr_stack_depth

## DeleteConfigurationVariable

int(* CSOUND_::DeleteConfigurationVariable) (CSOUND *, const char *name)

## DestroyBarrier

int(* CSOUND_::DestroyBarrier) (void *)

## DestroyCircularBuffer

void(* CSOUND_::DestroyCircularBuffer) (CSOUND *, void *)

## DestroyGlobalVariable

int(* CSOUND_::DestroyGlobalVariable) (CSOUND *, const char *name)

## DestroyMutex

void(* CSOUND_::DestroyMutex) (void *mutex_)

## DestroyThreadLock

void(* CSOUND_::DestroyThreadLock) (void *lock)

## Die

CS_NORETURN CS_PRINTF2 void(* CSOUND_::Die) (CSOUND *, const char *msg,...)

## directory

void* CSOUND_::directory

## disable_csd_options

int CSOUND_::disable_csd_options

## dispexit

int(* CSOUND_::dispexit) (CSOUND *)

## dispinit

void(* CSOUND_::dispinit) (CSOUND *)

## display

void(* CSOUND_::display) (CSOUND *, WINDAT *)

## disprep_fftcoefs

MYFLT* CSOUND_::disprep_fftcoefs

## dispset

void(* CSOUND_::dispset) (CSOUND *, WINDAT *, MYFLT *, int32, char *, int, char *)

## dither_output

int CSOUND_::dither_output

## dl_opcodes_oplibs

char* CSOUND_::dl_opcodes_oplibs

## doCsoundCallback

int(* CSOUND_::doCsoundCallback) (CSOUND *, void *, unsigned int)

## dummyfn_2

SUBR CSOUND_::dummyfn_2[22]

## e0dbfs

MYFLT CSOUND_::e0dbfs

## ekr

MYFLT CSOUND_::ekr

## enableHostImplementedAudioIO

int CSOUND_::enableHostImplementedAudioIO

## enableHostImplementedMIDIIO

int CSOUND_::enableHostImplementedMIDIIO

## enableMsgAttr

int CSOUND_::enableMsgAttr

## engineState

ENGINE_STATE CSOUND_::engineState

## engineStatus

char CSOUND_::engineStatus

## envVarDB

CS_HASH_TABLE* CSOUND_::envVarDB

## ErrMsgV

void(* CSOUND_::ErrMsgV) (CSOUND *, const char *hdr, const char *fmt, va_list)

## ErrorMsg

CS_PRINTF2 void(* CSOUND_::ErrorMsg) (CSOUND *, const char *fmt,...)

## esr

MYFLT CSOUND_::esr

## event_insert_loop

int CSOUND_::event_insert_loop

## event_insert_thread

void* CSOUND_::event_insert_thread

## evt

EVTBLK CSOUND_::evt

## evt_poll_cnt

int CSOUND_::evt_poll_cnt

## evt_poll_maxcnt

int CSOUND_::evt_poll_maxcnt

## evtFuncChain

void* CSOUND_::evtFuncChain

## exitjmp

jmp_buf CSOUND_::exitjmp

## expanded_orc

CORFIL* CSOUND_::expanded_orc

## expanded_sco

CORFIL* CSOUND_::expanded_sco

## FDClose

void(* CSOUND_::FDClose) (CSOUND *, FDCH *fdchp)

## FDRecord

void(* CSOUND_::FDRecord) (CSOUND *, FDCH *fdchp)

## FFT_max_size

int CSOUND_::FFT_max_size

## FFT_table_1

void* CSOUND_::FFT_table_1

## FFT_table_2

void* CSOUND_::FFT_table_2

## file_io_start

int CSOUND_::file_io_start

## file_io_thread

void* CSOUND_::file_io_thread

## file_io_threadlock

void* CSOUND_::file_io_threadlock

## FileClose

int(* CSOUND_::FileClose) (CSOUND *, void *)

## filedir

char* CSOUND_::filedir[256]

## FileOpen2

void *(* CSOUND_::FileOpen2) (CSOUND *, void *, int, const char *, void *, const char *, int, int)

## FileOpenAsync

void *(* CSOUND_::FileOpenAsync) (CSOUND *, void *, int, const char *, void *, const char *, int, int, int)

## FileOpenCallback_

void(* CSOUND_::FileOpenCallback_) (CSOUND *, const char *, int, int, int)

## find_opcode_exact

OENTRY *(* CSOUND_::find_opcode_exact) (CSOUND *, char *, char *, char *)

## find_opcode_new

OENTRY *(* CSOUND_::find_opcode_new) (CSOUND *, char *, char *, char *)

## FindInputFile

char *(* CSOUND_::FindInputFile) (CSOUND *, const char *filename, const char *envList)

## FindOutputFile

char *(* CSOUND_::FindOutputFile) (CSOUND *, const char *filename, const char *envList)

## first_callback_

SUBR CSOUND_::first_callback_

## first_delayr

void* CSOUND_::first_delayr

## flist

FUNC** CSOUND_::flist

## FlushCircularBuffer

void(* CSOUND_::FlushCircularBuffer) (CSOUND *, void *)

## Free

void(* CSOUND_::Free) (CSOUND *, void *ptr)

## freeEvtNodes

EVTNODE* CSOUND_::freeEvtNodes

## frstbp

SRTBLK* CSOUND_::frstbp

## frstoff

INSDS* CSOUND_::frstoff

## FSeekAsync

int(* CSOUND_::FSeekAsync) (CSOUND *, void *, int, int)

## FTAlloc

int(* CSOUND_::FTAlloc) (CSOUND *, int tableNum, int len)

## FTDelete

int(* CSOUND_::FTDelete) (CSOUND *, int tableNum)

## ftError

int(* CSOUND_::ftError) (const FGDATA *, const char *,...)

## FTFind

FUNC *(* CSOUND_::FTFind) (CSOUND *, MYFLT *argp)

Find tables with power of two size.

If table exists but is not a power of 2, NULL is returned.

## FTFindP

FUNC *(* CSOUND_::FTFindP) (CSOUND *, MYFLT *argp)

Find any table, except deferred load tables.

## FTnp2Find

FUNC *(* CSOUND_::FTnp2Find) (CSOUND *, MYFLT *argp)

Find any table.

## FTnp2Finde

FUNC *(* CSOUND_::FTnp2Finde) (CSOUND *, MYFLT *)

## gbloffbas

MYFLT* CSOUND_::gbloffbas

## genmax

int CSOUND_::genmax

## gensub

GEN* CSOUND_::gensub

## Get0dBFS

MYFLT(* CSOUND_::Get0dBFS) (CSOUND *)

## GetA4

MYFLT(* CSOUND_::GetA4) (CSOUND *csound)

## GetChannelPtr

int(* CSOUND_::GetChannelPtr) (CSOUND *, MYFLT **, const char *, int)

## GetCPUTime

double(* CSOUND_::GetCPUTime) (RTCLOCK *)

## GetCurrentThreadID

void *(* CSOUND_::GetCurrentThreadID) (void)

## GetCurrentTimeSamples

int64_t(* CSOUND_::GetCurrentTimeSamples) (CSOUND *)

## GetDebug

int(* CSOUND_::GetDebug) (CSOUND *)

## GetDitherMode

int(* CSOUND_::GetDitherMode) (CSOUND *)

## GetEnv

const char *(* CSOUND_::GetEnv) (CSOUND *, const char *name)

Get environment variable.

## GetErrorCnt

int(* CSOUND_::GetErrorCnt) (CSOUND *)

## GetFileName

char *(* CSOUND_::GetFileName) (void *)

## GetHostData

void *(* CSOUND_::GetHostData) (CSOUND *)

## GetInputArgCnt

int(* CSOUND_::GetInputArgCnt) (void *p)

## GetInputArgName

char *(* CSOUND_::GetInputArgName) (void *p, int n)

## GetInputBuffer

MYFLT *(* CSOUND_::GetInputBuffer) (CSOUND *)

## GetInputBufferSize

long(* CSOUND_::GetInputBufferSize) (CSOUND *)

## GetInstrument

INSTRTXT *(* CSOUND_::GetInstrument) (CSOUND *, int, const char *)

## GetInstrumentList

INSTRTXT **(* CSOUND_::GetInstrumentList) (CSOUND *)

## GetInstrumentNumber

int(* CSOUND_::GetInstrumentNumber) (void *p)

## GetInverseComplexFFTScale

MYFLT(* CSOUND_::GetInverseComplexFFTScale) (CSOUND *, int FFTsize)

## GetInverseRealFFTScale

MYFLT(* CSOUND_::GetInverseRealFFTScale) (CSOUND *, int FFTsize)

## GetKcounter

uint64_t(* CSOUND_::GetKcounter) (CSOUND *)

Get number of control blocks elapsed.

## GetKr

MYFLT(* CSOUND_::GetKr) (CSOUND *)

## GetKsmps

uint32_t(* CSOUND_::GetKsmps) (CSOUND *)

## GetLibrarySymbol

void *(* CSOUND_::GetLibrarySymbol) (void *library, const char *procedureName)

## GetMessageLevel

int(* CSOUND_::GetMessageLevel) (CSOUND *)

## GetMidiChannel

MCHNBLK *(* CSOUND_::GetMidiChannel) (void *p)

## GetMidiChannelNumber

int(* CSOUND_::GetMidiChannelNumber) (void *p)

## GetMidiNoteNumber

int(* CSOUND_::GetMidiNoteNumber) (void *p)

## GetMidiVelocity

int(* CSOUND_::GetMidiVelocity) (void *p)

## GetNamedGens

void *(* CSOUND_::GetNamedGens) (CSOUND *)

## GetNchnls

uint32_t(* CSOUND_::GetNchnls) (CSOUND *)

Get number of output channels.

## GetNchnls_i

uint32_t(* CSOUND_::GetNchnls_i) (CSOUND *)

Get number of input channels.

## GetOffTime

double(* CSOUND_::GetOffTime) (void *p)

## GetOParms

void(* CSOUND_::GetOParms) (CSOUND *, OPARMS *)

## GetOpcodeName

char *(* CSOUND_::GetOpcodeName) (void *p)

## GetOutputArgCnt

int(* CSOUND_::GetOutputArgCnt) (void *p)

## GetOutputArgName

char *(* CSOUND_::GetOutputArgName) (void *p, int n)

## GetOutputBuffer

MYFLT *(* CSOUND_::GetOutputBuffer) (CSOUND *)

## GetOutputBufferSize

long(* CSOUND_::GetOutputBufferSize) (CSOUND *)

## GetPFields

MYFLT *(* CSOUND_::GetPFields) (void *p)

## GetRandomSeedFromTime

uint32_t(* CSOUND_::GetRandomSeedFromTime) (void)

## GetRandSeed

int(* CSOUND_::GetRandSeed) (CSOUND *, int which)

## GetRealTime

double(* CSOUND_::GetRealTime) (RTCLOCK *)

## GetReinitFlag

int(* CSOUND_::GetReinitFlag) (CSOUND *)

## GetReleaseFlag

int(* CSOUND_::GetReleaseFlag) (void *p)

## GetRtPlayUserData

void **(* CSOUND_::GetRtPlayUserData) (CSOUND *)

## GetRtRecordUserData

void **(* CSOUND_::GetRtRecordUserData) (CSOUND *)

## GetScoreOffsetSeconds

MYFLT(* CSOUND_::GetScoreOffsetSeconds) (CSOUND *)

## GetSizeOfMYFLT

int(* CSOUND_::GetSizeOfMYFLT) (void)

## getsndin

int(* CSOUND_::getsndin) (CSOUND *, void *, MYFLT *, int, void *)

## GetSr

MYFLT(* CSOUND_::GetSr) (CSOUND *)

## getstrformat

char *(* CSOUND_::getstrformat) (int format)

## GetString

char *(* CSOUND_::GetString) (CSOUND *, MYFLT)

## GetStrsets

char *(* CSOUND_::GetStrsets) (CSOUND *, long)

## GetStrsmax

int(* CSOUND_::GetStrsmax) (CSOUND *)

Current maximum number of strings, accessible through the strset and strget opcodes.

## GetTable

int(* CSOUND_::GetTable) (CSOUND *, MYFLT **tablePtr, int tableNum)

## GetTieFlag

int(* CSOUND_::GetTieFlag) (CSOUND *)

## GetTypeForArg

CS_TYPE *(* CSOUND_::GetTypeForArg) (void *p)

## GetUtilityDescription

const char *(* CSOUND_::GetUtilityDescription) (CSOUND *, const char *utilName)

## GetZaBounds

int(* CSOUND_::GetZaBounds) (CSOUND *, MYFLT **)

## GetZakBounds

int(* CSOUND_::GetZakBounds) (CSOUND *, MYFLT **)

## global_kcounter

uint64_t CSOUND_::global_kcounter

## hfgens

int(* CSOUND_::hfgens) (CSOUND *, FUNC **, const EVTBLK *, int)

## holdrand

int CSOUND_::holdrand

## hostdata

void* CSOUND_::hostdata

## hostRequestedBufferSize

int CSOUND_::hostRequestedBufferSize

## ibeatTime

int64_t CSOUND_::ibeatTime

beat time = 60 / tempo

## icurTime

int64_t CSOUND_::icurTime

current time in seconds, inc.

per kprd

## ids

OPDS* CSOUND_::ids

## inChar_

int CSOUND_::inChar_

## inchnls

int CSOUND_::inchnls

## inerrcnt

int CSOUND_::inerrcnt

## info_message_request

int CSOUND_::info_message_request

## inInstr

int CSOUND_::inInstr

## init_event

EVTBLK* CSOUND_::init_event

## init_pass_threadlock

void* CSOUND_::init_pass_threadlock

## InitError

CS_PRINTF2 int(* CSOUND_::InitError) (CSOUND *, const char *msg,...)

## initonly

int CSOUND_::initonly

## InitTimerStruct

void(* CSOUND_::InitTimerStruct) (RTCLOCK *)

## InputChannelCallback_

channelCallback_t CSOUND_::InputChannelCallback_

## InputMessage

void(* CSOUND_::InputMessage) (CSOUND *, const char *message__)

## insert_score_event

int(* CSOUND_::insert_score_event) (CSOUND *, EVTBLK *, double)

## insert_score_event_at_sample

int(* CSOUND_::insert_score_event_at_sample) (CSOUND *, EVTBLK *, int64_t)

## instCurr

struct instr_semantics_t* CSOUND_::instCurr

## instr0

INSTRTXT* CSOUND_::instr0

## instRoot

struct instr_semantics_t* CSOUND_::instRoot

## int1

int CSOUND_::int1

## intpow

MYFLT(* CSOUND_::intpow) (MYFLT, int32)

## InverseComplexFFT

void(* CSOUND_::InverseComplexFFT) (CSOUND *, MYFLT *buf, int FFTsize)

## InverseRealFFT

void(* CSOUND_::InverseRealFFT) (CSOUND *, MYFLT *buf, int FFTsize)

## InverseRealFFTnp2

void(* CSOUND_::InverseRealFFTnp2) (CSOUND *, MYFLT *buf, int FFTsize)

## inZero

int CSOUND_::inZero

## io_initialised

int CSOUND_::io_initialised

## isGraphable_

int CSOUND_::isGraphable_

## isintab

int16* CSOUND_::isintab

## ISSTRCOD

int(* CSOUND_::ISSTRCOD) (MYFLT)

## JoinThread

uintptr_t(* CSOUND_::JoinThread) (void *thread)

## jumpset

int CSOUND_::jumpset

## kcounter

uint64_t CSOUND_::kcounter

## keep_tmp

int CSOUND_::keep_tmp

## kicvt

MYFLT CSOUND_::kicvt

## kperf

int(* CSOUND_::kperf) (CSOUND *)

## ksmps

unsigned int CSOUND_::ksmps

## last_callback_

SUBR CSOUND_::last_callback_

## last_delayr

void* CSOUND_::last_delayr

## ldmemfile2withCB

MEMFIL *(* CSOUND_::ldmemfile2withCB) (CSOUND *, const char *, int, int(*callback)(CSOUND *, MEMFIL *))

## libsndStatics

struct CSOUND_::libsndStatics__ CSOUND_::libsndStatics

## Linefd

int CSOUND_::Linefd

## Linepipe

FILE* CSOUND_::Linepipe

## lineventStatics

struct CSOUND_::lineventStatics__ CSOUND_::lineventStatics

## ListChannels

int(* CSOUND_::ListChannels) (CSOUND *, controlChannelInfo_t **)

## ListConfigurationVariables

csCfgVariable_t **(* CSOUND_::ListConfigurationVariables) (CSOUND *)

## ListUtilities

char **(* CSOUND_::ListUtilities) (CSOUND *)

## LoadSoundFile

SNDMEMFILE *(* CSOUND_::LoadSoundFile) (CSOUND *, const char *, void *)

## LocalizeString

char *(* CSOUND_::LocalizeString) (const char *) __attribute__((format_arg(1)))

## LockMutex

void(* CSOUND_::LockMutex) (void *mutex_)

## LockMutexNoWait

int(* CSOUND_::LockMutexNoWait) (void *mutex_)

## logbase2

MYFLT* CSOUND_::logbase2

## LongJmp

CS_NORETURN void(* CSOUND_::LongJmp) (CSOUND *, int)

## LPCeps

MYFLT *(* CSOUND_::LPCeps) (CSOUND *, MYFLT *, MYFLT *, int, int)

## LPfree

void(* CSOUND_::LPfree) (CSOUND *csound, void *)

## lprdaddr

void* CSOUND_::lprdaddr

## LPred

MYFLT *(* CSOUND_::LPred) (CSOUND *, void *, MYFLT *)

## LPrms

MYFLT(* CSOUND_::LPrms) (CSOUND *, void *)

## LPsetup

void *(* CSOUND_::LPsetup) (CSOUND *csound, int N, int M)

## m_chnbp

MCHNBLK* CSOUND_::m_chnbp[MIDIMAXPORTS *16]

reserve space for up to MIDIMAXPORTS MIDI devices

## Malloc

void *(* CSOUND_::Malloc) (CSOUND *, size_t nbytes)

## max_lpc_slot

int CSOUND_::max_lpc_slot

## maxamp

MYFLT CSOUND_::maxamp[MAXCHNLS]

## maxfnum

int CSOUND_::maxfnum

## maxpos

uint32 CSOUND_::maxpos[MAXCHNLS]

## memalloc_db

void* CSOUND_::memalloc_db

## memfiles

MEMFIL* CSOUND_::memfiles

## memlock

spin_lock_t CSOUND_::memlock

## Message

CS_PRINTF2 void(* CSOUND_::Message) (CSOUND *, const char *fmt,...)

## message_buffer

void* CSOUND_::message_buffer

## message_string

char* CSOUND_::message_string

## message_string_queue

message_string_queue_t* CSOUND_::message_string_queue

## message_string_queue_items

volatile unsigned long CSOUND_::message_string_queue_items

## message_string_queue_wp

unsigned long CSOUND_::message_string_queue_wp

## MessageS

CS_PRINTF3 void(* CSOUND_::MessageS) (CSOUND *, int attr, const char *fmt,...)

## MessageV

void(* CSOUND_::MessageV) (CSOUND *, int attr, const char *format, va_list args)

## Mforcdecs

int CSOUND_::Mforcdecs

## midi_dev_list_callback

int(* CSOUND_::midi_dev_list_callback) (CSOUND *, CS_MIDIDEVICE *, int)

## midiGlobals

MGLOBAL* CSOUND_::midiGlobals

## mode

int CSOUND_::mode

## module_list_add

void(* CSOUND_::module_list_add) (CSOUND *, char *, char *)

## modules_loaded

int CSOUND_::modules_loaded

## mp3_mode

int CSOUND_::mp3_mode

## mpidsr

MYFLT CSOUND_::mpidsr

## msg_queue

struct _message_queue** CSOUND_::msg_queue

## msg_queue_items

volatile long CSOUND_::msg_queue_items

## msg_queue_rstart

volatile long CSOUND_::msg_queue_rstart

## msg_queue_wget

volatile long CSOUND_::msg_queue_wget

## msg_queue_wput

volatile long CSOUND_::msg_queue_wput

## mtpdsr

MYFLT CSOUND_::mtpdsr

## MTrkend

int CSOUND_::MTrkend

## multichan

int16 CSOUND_::multichan

## multiThreadedComplete

int CSOUND_::multiThreadedComplete

## multiThreadedDag

struct dag_t* CSOUND_::multiThreadedDag

## multiThreadedThreadInfo

THREADINFO* CSOUND_::multiThreadedThreadInfo

## musmonStatics

struct CSOUND_::musmonStatics__ CSOUND_::musmonStatics

## Mxtroffs

int CSOUND_::Mxtroffs

## namedgen

void* CSOUND_::namedgen

## namedGlobals

CS_HASH_TABLE* CSOUND_::namedGlobals

## nchanif

int CSOUND_::nchanif

## nchanof

int CSOUND_::nchanof

## nchnls

uint32_t CSOUND_::nchnls

## NotifyFileOpened

void(* CSOUND_::NotifyFileOpened) (CSOUND *, const char *, int, int, int)

## NotifyThreadLock

void(* CSOUND_::NotifyThreadLock) (void *lock)

## nrecs

int32 CSOUND_::nrecs

## nspin

int CSOUND_::nspin

## nspout

int CSOUND_::nspout

## nxtbt

double CSOUND_::nxtbt

## nxtim

double CSOUND_::nxtim

## omacros

NAMES* CSOUND_::omacros

## omaxamp

MYFLT CSOUND_::omaxamp[MAXCHNLS]

## omaxpos

uint32 CSOUND_::omaxpos[MAXCHNLS]

## onedkr

MYFLT CSOUND_::onedkr

## onedksmps

MYFLT CSOUND_::onedksmps

## onedsr

MYFLT CSOUND_::onedsr

## onefileStatics

struct CSOUND_::onefileStatics__ CSOUND_::onefileStatics

## op

char* CSOUND_::op

## oparms

OPARMS* CSOUND_::oparms

## oparms_

OPARMS CSOUND_::oparms_

## opcodedir

char* CSOUND_::opcodedir

## opcodedirWasOK

int CSOUND_::opcodedirWasOK

## opcodeInfo

OPCODINFO* CSOUND_::opcodeInfo

## opcodes

CS_HASH_TABLE* CSOUND_::opcodes

## open_files

void* CSOUND_::open_files

## OpenLibrary

int(* CSOUND_::OpenLibrary) (void **library, const char *libraryPath)

## orc_macros

MACRO* CSOUND_::orc_macros

## orchname

char* CSOUND_::orchname

## orchstr

CORFIL* CSOUND_::orchstr

## orcLineOffset

int CSOUND_::orcLineOffset

## orcname_mode

char CSOUND_::orcname_mode

## OrcTrigEvts

EVTNODE* CSOUND_::OrcTrigEvts

## oscfp

FILE* CSOUND_::oscfp

## OutputChannelCallback_

channelCallback_t CSOUND_::OutputChannelCallback_

## ParseConfigurationVariable

int(* CSOUND_::ParseConfigurationVariable) (CSOUND *, const char *name, const char *value)

## parserNamedInstrFlag

int CSOUND_::parserNamedInstrFlag

## parserUdoflag

int CSOUND_::parserUdoflag

## peakchunks

int CSOUND_::peakchunks

## perferrcnt

int CSOUND_::perferrcnt

## PerfError

CS_PRINTF3 int(* CSOUND_::PerfError) (CSOUND *, OPDS *h, const char *msg,...)

## PerformKsmps

int(* CSOUND_::PerformKsmps) (CSOUND *)

## performState

int CSOUND_::performState

## pidsr

MYFLT CSOUND_::pidsr

## playopen_callback

int(* CSOUND_::playopen_callback) (CSOUND *, const csRtAudioParams *parm)

## pointer1

void* CSOUND_::pointer1

## pointer2

void* CSOUND_::pointer2

## Pow2

MYFLT(* CSOUND_::Pow2) (CSOUND *, MYFLT a)

## print_version

int CSOUND_::print_version

## printerrormessagesflag

void* CSOUND_::printerrormessagesflag

## prvbt

double CSOUND_::prvbt

## pvErrorCode

int CSOUND_::pvErrorCode

## pvFileTable

void* CSOUND_::pvFileTable

## pvNumFiles

int CSOUND_::pvNumFiles

## PVOC_CloseFile

int(* CSOUND_::PVOC_CloseFile) (CSOUND *, int)

## PVOC_CreateFile

int(* CSOUND_::PVOC_CreateFile) (CSOUND *, const char *, uint32, uint32, uint32, uint32, int32, int, int, float, float *, uint32)

## PVOC_ErrorString

const char *(* CSOUND_::PVOC_ErrorString) (CSOUND *)

## PVOC_FrameCount

int(* CSOUND_::PVOC_FrameCount) (CSOUND *, int)

## PVOC_fseek

int(* CSOUND_::PVOC_fseek) (CSOUND *, int, int)

## PVOC_GetFrames

int(* CSOUND_::PVOC_GetFrames) (CSOUND *, int, float *, uint32)

## PVOC_OpenFile

int(* CSOUND_::PVOC_OpenFile) (CSOUND *, const char *, void *, void *)

## PVOC_PutFrames

int(* CSOUND_::PVOC_PutFrames) (CSOUND *, int, const float *, int32)

## PVOCEX_LoadFile

int(* CSOUND_::PVOCEX_LoadFile) (CSOUND *, const char *, PVOCEX_MEMFILE *)

## pvx_memfiles

PVOCEX_MEMFILE* CSOUND_::pvx_memfiles

## QueryConfigurationVariable

csCfgVariable_t *(* CSOUND_::QueryConfigurationVariable) (CSOUND *, const char *name)

## QueryGlobalVariable

void *(* CSOUND_::QueryGlobalVariable) (CSOUND *, const char *name)

## QueryGlobalVariableNoCheck

void *(* CSOUND_::QueryGlobalVariableNoCheck) (CSOUND *, const char *name)

## Rand31

int(* CSOUND_::Rand31) (int *seedVal)

## RandMT

uint32_t(* CSOUND_::RandMT) (CsoundRandMTState *p)

## randSeed1

int CSOUND_::randSeed1

## randSeed2

int CSOUND_::randSeed2

## randState_

CsoundRandMTState CSOUND_::randState_

## ReadAsync

unsigned int(* CSOUND_::ReadAsync) (CSOUND *, void *, MYFLT *, int)

## ReadCircularBuffer

int(* CSOUND_::ReadCircularBuffer) (CSOUND *, void *, void *, int)

## RealFFT

void(* CSOUND_::RealFFT) (CSOUND *, MYFLT *buf, int FFTsize)

## RealFFT2

void(* CSOUND_::RealFFT2) (CSOUND *csound, void *p, MYFLT *sig)

## RealFFT2Setup

void *(* CSOUND_::RealFFT2Setup) (CSOUND *csound, int FFTsize, int d)

## RealFFTMult

void(* CSOUND_::RealFFTMult) (CSOUND *, MYFLT *outbuf, MYFLT *buf1, MYFLT *buf2, int FFTsize, MYFLT scaleFac)

## RealFFTnp2

void(* CSOUND_::RealFFTnp2) (CSOUND *, MYFLT *buf, int FFTsize)

## ReAlloc

void *(* CSOUND_::ReAlloc) (CSOUND *, void *oldp, size_t nbytes)

## realtime_audio_flag

int CSOUND_::realtime_audio_flag

## recopen_callback

int(* CSOUND_::recopen_callback) (CSOUND *, const csRtAudioParams *parm)

## RegisterDeinitCallback

int(* CSOUND_::RegisterDeinitCallback) (CSOUND *, void *p, int(*func)(CSOUND *, void *))

## RegisterResetCallback

int(* CSOUND_::RegisterResetCallback) (CSOUND *, void *userData, int(*func)(CSOUND *, void *))

## RegisterSenseEventCallback

int(* CSOUND_::RegisterSenseEventCallback) (CSOUND *, void(*func)(CSOUND *, void *), void *userData)

## reinitflag

int CSOUND_::reinitflag

## remoteGlobals

void* CSOUND_::remoteGlobals

## Remove_KeyCallback

void(* CSOUND_::Remove_KeyCallback) (CSOUND *, int(*func)(void *, void *, unsigned int))

## reset_list

void* CSOUND_::reset_list

## revlpsiz

int32 CSOUND_::revlpsiz[6]

## revlpsum

int32 CSOUND_::revlpsum

## RewindScore

void(* CSOUND_::RewindScore) (CSOUND *)

## rewriteheader

void(* CSOUND_::rewriteheader) (void *ofd)

## rndfrac

double CSOUND_::rndfrac

## rngcnt

int32 CSOUND_::rngcnt[MAXCHNLS]

## rngflg

int16 CSOUND_::rngflg

## rtclose_callback

void(* CSOUND_::rtclose_callback) (CSOUND *)

## rtplay_callback

void(* CSOUND_::rtplay_callback) (CSOUND *, const MYFLT *outBuf, int nbytes)

## rtPlay_userdata

void* CSOUND_::rtPlay_userdata

## rtrecord_callback

int(* CSOUND_::rtrecord_callback) (CSOUND *, MYFLT *inBuf, int nbytes)

## rtRecord_userdata

void* CSOUND_::rtRecord_userdata

## RunCommand

long(* CSOUND_::RunCommand) (const char *const *argv, int noWait)

## RunUtility

int(* CSOUND_::RunUtility) (CSOUND *, const char *name, int argc, char **argv)

## sampsNeeded

int CSOUND_::sampsNeeded

## SAsndgetset

void *(* CSOUND_::SAsndgetset) (CSOUND *, char *, void *, MYFLT *, MYFLT *, MYFLT *, int)

## scfp

FILE* CSOUND_::scfp

## schedule_kicked

void* CSOUND_::schedule_kicked

## scnt

int CSOUND_::scnt

## scoLineOffset

int CSOUND_::scoLineOffset

## score_parser

int CSOUND_::score_parser

## score_srt

char* CSOUND_::score_srt

## scorein

FILE* CSOUND_::scorein

## scorename

char * CSOUND_::scorename

## scoreout

FILE* CSOUND_::scoreout

## scorestr

CORFIL * CSOUND_::scorestr

## scstr

CORFIL* CSOUND_::scstr

## searchPathCache

void* CSOUND_::searchPathCache

## sectcnt

int CSOUND_::sectcnt

## SeedRandMT

void(* CSOUND_::SeedRandMT) (CsoundRandMTState *p, const uint32_t *initKey, uint32_t keyLength)

## Set_KeyCallback

int(* CSOUND_::Set_KeyCallback) (CSOUND *, int(*func)(void *, void *, unsigned int), void *userData, unsigned int typeMask)

## SetAudioDeviceListCallback

void(* CSOUND_::SetAudioDeviceListCallback) (CSOUND *csound, int(*audiodevlist__)(CSOUND *, CS_AUDIODEVICE *list, int isOutput))

## SetConfigurationVariable

int(* CSOUND_::SetConfigurationVariable) (CSOUND *, const char *name, void *value)

## SetDebug

void(* CSOUND_::SetDebug) (CSOUND *, int d)

Set internal debug mode.

## SetDrawGraphCallback

void(* CSOUND_::SetDrawGraphCallback) (CSOUND *, void(*drawGraphCallback)(CSOUND *, WINDAT *p))

## SetExitGraphCallback

void(* CSOUND_::SetExitGraphCallback) (CSOUND *, int(*exitGraphCallback)(CSOUND *))

## SetExternalMidiErrorStringCallback

void(* CSOUND_::SetExternalMidiErrorStringCallback) (CSOUND *, const char *(*func)(int))

## SetExternalMidiInCloseCallback

void(* CSOUND_::SetExternalMidiInCloseCallback) (CSOUND *, int(*func)(CSOUND *, void *))

## SetExternalMidiInOpenCallback

void(* CSOUND_::SetExternalMidiInOpenCallback) (CSOUND *, int(*func)(CSOUND *, void **, const char *))

## SetExternalMidiOutCloseCallback

void(* CSOUND_::SetExternalMidiOutCloseCallback) (CSOUND *, int(*func)(CSOUND *, void *))

## SetExternalMidiOutOpenCallback

void(* CSOUND_::SetExternalMidiOutOpenCallback) (CSOUND *, int(*func)(CSOUND *, void **, const char *))

## SetExternalMidiReadCallback

void(* CSOUND_::SetExternalMidiReadCallback) (CSOUND *, int(*func)(CSOUND *, void *, unsigned char *, int))

## SetExternalMidiWriteCallback

void(* CSOUND_::SetExternalMidiWriteCallback) (CSOUND *, int(*func)(CSOUND *, void *, const unsigned char *, int))

## SetInternalYieldCallback

void(* CSOUND_::SetInternalYieldCallback) (CSOUND *, int(*yieldCallback)(CSOUND *))

## SetIsGraphable

int(* CSOUND_::SetIsGraphable) (CSOUND *, int isGraphable)

## SetKillGraphCallback

void(* CSOUND_::SetKillGraphCallback) (CSOUND *, void(*killGraphCallback)(CSOUND *, WINDAT *p))

## SetMakeGraphCallback

void(* CSOUND_::SetMakeGraphCallback) (CSOUND *, void(*makeGraphCallback)(CSOUND *, WINDAT *p, const char *name))

## SetMessageCallback

void(* CSOUND_::SetMessageCallback) (CSOUND *, void(*csoundMessageCallback)(CSOUND *, int attr, const char *format, va_list valist))

## SetMessageLevel

void(* CSOUND_::SetMessageLevel) (CSOUND *, int messageLevel)

## SetMIDIDeviceListCallback

void(* CSOUND_::SetMIDIDeviceListCallback) (CSOUND *csound, int(*audiodevlist__)(CSOUND *, CS_MIDIDEVICE *list, int isOutput))

## SetPlayopenCallback

void(* CSOUND_::SetPlayopenCallback) (CSOUND *, int(*playopen__)(CSOUND *, const csRtAudioParams *parm))

## SetRecopenCallback

void(* CSOUND_::SetRecopenCallback) (CSOUND *, int(*recopen__)(CSOUND *, const csRtAudioParams *parm))

## SetReleaseLength

int(* CSOUND_::SetReleaseLength) (void *p, int n)

## SetReleaseLengthSeconds

MYFLT(* CSOUND_::SetReleaseLengthSeconds) (void *p, MYFLT n)

## SetRtcloseCallback

void(* CSOUND_::SetRtcloseCallback) (CSOUND *, void(*rtclose__)(CSOUND *))

## SetRtplayCallback

void(* CSOUND_::SetRtplayCallback) (CSOUND *, void(*rtplay__)(CSOUND *, const MYFLT *outBuf, int nbytes))

## SetRtrecordCallback

void(* CSOUND_::SetRtrecordCallback) (CSOUND *, int(*rtrecord__)(CSOUND *, MYFLT *inBuf, int nbytes))

## SetScoreOffsetSeconds

void(* CSOUND_::SetScoreOffsetSeconds) (CSOUND *, MYFLT offset)

## SetUtilityDescription

int(* CSOUND_::SetUtilityDescription) (CSOUND *, const char *utilName, const char *utilDesc)

## SetUtilNchnls

void(* CSOUND_::SetUtilNchnls) (CSOUND *, int)

## SetUtilSr

void(* CSOUND_::SetUtilSr) (CSOUND *, MYFLT)

## SetYieldCallback

void(* CSOUND_::SetYieldCallback) (CSOUND *, int(*yieldCallback)(CSOUND *))

## SF_csd_licence

char* CSOUND_::SF_csd_licence

## SF_id_artist

char* CSOUND_::SF_id_artist

## SF_id_comment

char* CSOUND_::SF_id_comment

## SF_id_copyright

char* CSOUND_::SF_id_copyright

## SF_id_date

char* CSOUND_::SF_id_date

## SF_id_scopyright

int CSOUND_::SF_id_scopyright

## SF_id_software

char* CSOUND_::SF_id_software

## SF_id_title

char* CSOUND_::SF_id_title

## sfsampsize

int(* CSOUND_::sfsampsize) (int format)

## sftype2csfiletype

int(* CSOUND_::sftype2csfiletype) (int type)

## sicvt

MYFLT CSOUND_::sicvt

## sinelength

int CSOUND_::sinelength

## sinetable

FUNC* CSOUND_::sinetable

## Sleep

void(* CSOUND_::Sleep) (size_t milliseconds)

## smacros

NAMES * CSOUND_::smacros

## smaxamp

MYFLT CSOUND_::smaxamp[MAXCHNLS]

## smaxpos

uint32 CSOUND_::smaxpos[MAXCHNLS]

## sndgetset

void *(* CSOUND_::sndgetset) (CSOUND *, void *)

## sndmemfiles

CS_HASH_TABLE* CSOUND_::sndmemfiles

## spin

MYFLT* CSOUND_::spin

## spinlock

spin_lock_t CSOUND_::spinlock

## spinlock1

spin_lock_t CSOUND_::spinlock1

## spinrecv

void(* CSOUND_::spinrecv) (CSOUND *)

## spout

MYFLT* CSOUND_::spout

## spoutactive

int CSOUND_::spoutactive

## spoutlock

spin_lock_t CSOUND_::spoutlock

## spoutran

void(* CSOUND_::spoutran) (CSOUND *)

## spraw

MYFLT* CSOUND_::spraw

## sprintf

int(* CSOUND_::sprintf) (char *str, const char *format,...)

## sread

struct CSOUND_::sread__ CSOUND_::sread

## sscanf

int(* CSOUND_::sscanf) (char *str, const char *format,...)

## sstrbuf

char* CSOUND_::sstrbuf

## sstrlen

int CSOUND_::sstrlen

## stdin_assign_flg

char CSOUND_::stdin_assign_flg

## stdOp_Env

void* CSOUND_::stdOp_Env

reserved for std opcode library

## stdout_assign_flg

char CSOUND_::stdout_assign_flg

## strarg2insno

int32(* CSOUND_::strarg2insno) (CSOUND *, void *p, int is_string)

## strarg2name

char *(* CSOUND_::strarg2name) (CSOUND *, char *, void *, const char *, int)

## Strdup

char *(* CSOUND_::Strdup) (CSOUND *, char *)

## strNcpy

char *(* CSOUND_::strNcpy) (char *dst, const char *src, size_t siz)

## strsets

char** CSOUND_::strsets

## strsiz

int CSOUND_::strsiz

## strsmax

int CSOUND_::strsmax

## strtod

double(* CSOUND_::strtod) (char *, char **)

## strtok_r

char *(* CSOUND_::strtok_r) (char *, char *, char **)

## SVrecvbuf

REMOT_BUF CSOUND_::SVrecvbuf

## symbtab

CS_HASH_TABLE* CSOUND_::symbtab

## synterrcnt

int CSOUND_::synterrcnt

## system_sr

MYFLT(* CSOUND_::system_sr) (CSOUND *, MYFLT)

## TableGet

MYFLT(* CSOUND_::TableGet) (CSOUND *, int table, int index)

## TableLength

int(* CSOUND_::TableLength) (CSOUND *, int table)

## TableSet

void(* CSOUND_::TableSet) (CSOUND *, int table, int index, MYFLT value)

## tempStatus

uint32_t CSOUND_::tempStatus

## tieflag

int CSOUND_::tieflag

## timeOffs

double CSOUND_::timeOffs

start time of current section

## tpidsr

MYFLT CSOUND_::tpidsr

## tpsave

void * CSOUND_::tpsave

## tran_nchnlsi

int CSOUND_::tran_nchnlsi

## tseg

void* CSOUND_::tseg

## type2csfiletype

int(* CSOUND_::type2csfiletype) (int type, int encoding)

## type2string

char *(* CSOUND_::type2string) (int type)

## typePool

TYPE_POOL* CSOUND_::typePool

## ugens4_rand_15

int CSOUND_::ugens4_rand_15

## ugens4_rand_16

int CSOUND_::ugens4_rand_16

## UnlockMutex

void(* CSOUND_::UnlockMutex) (void *mutex_)

## UNUSEDP

MYFLT* CSOUND_::UNUSEDP

## use_only_orchfile

int CSOUND_::use_only_orchfile

## utility_db

void* CSOUND_::utility_db

## WaitBarrier

int(* CSOUND_::WaitBarrier) (void *)

## WaitThreadLock

int(* CSOUND_::WaitThreadLock) (void *lock, size_t milliseconds)

## WaitThreadLockNoTimeout

void(* CSOUND_::WaitThreadLockNoTimeout) (void *lock)

## Warning

CS_PRINTF2 void(* CSOUND_::Warning) (CSOUND *, const char *msg,...)

## warped

int CSOUND_::warped

## winEPS_globals

void* CSOUND_::winEPS_globals

## WriteAsync

unsigned int(* CSOUND_::WriteAsync) (CSOUND *, void *, MYFLT *, int)

## WriteCircularBuffer

int(* CSOUND_::WriteCircularBuffer) (CSOUND *, void *, const void *, int)

## xfilename

char* CSOUND_::xfilename